﻿using System;
using System.ComponentModel;
using System.Linq.Expressions;

namespace MapGeometryDemo
{
    [Serializable]
    public abstract class BindableObject : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        
        public void RaisePropertyChanged<T>(Expression<Func<T>> propertyExpression)
        {
            var propertyChangedEvent = PropertyChanged;
            if (propertyChangedEvent != null)
            {
                var body = (MemberExpression)propertyExpression.Body;
                propertyChangedEvent(this, new PropertyChangedEventArgs(body.Member.Name));
            }
        }
    }
}
