﻿using System;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.Map;

namespace MapGeometryDemo
{
    public class ViewModel : BindableObject
    {
        private readonly ObservableCollection<Thing> _things;
        private readonly Group _group;
        private readonly ObservableCollection<Group> _groups;

        public ViewModel()
        {
            var direction = Math.PI/2;
            _things = new ObservableCollection<Thing> { new Thing(new Location(0, 0), direction), new Thing(new Location(0.1, 0.05), direction), new Thing(new Location(0.2, -0.05), direction) };
            _group = new Group(_things);
            _groups = new ObservableCollection<Group> { _group };
            MoveForwardCommand = new RelayCommand(MoveForward);
        }

        public ObservableCollection<Thing> Things
        {
            get { return _things; }
        }

        public RelayCommand MoveForwardCommand { get; set; }

        public ObservableCollection<Group> Groups
        {
            get { return _groups; }
        }

        private void MoveForward()
        {
            foreach (var thing in _things)
            {
                thing.Location = new Location(thing.Location.Latitude + 0.01, thing.Location.Longitude);
            }
        }
    }
}
